#include "pic12f609_writer.h"

void sendDataToPic(unsigned int data, int bitLength) {
  noInterrupts();
  for(int i=0;i<bitLength;i++) {
    digitalWrite(PIN_CLOCK, HIGH);
    digitalWrite(PIN_DATA, (data&(1u<<i))?HIGH:LOW);
    delayMicroseconds(TSET1);
    digitalWrite(PIN_CLOCK, LOW);
    delayMicroseconds(THLD1);
  }
  digitalWrite(PIN_DATA, LOW);
  interrupts();
}

unsigned int receiveDataFromPic(int bitLength) {
  unsigned int data=0;
  noInterrupts();
  pinMode(PIN_DATA, INPUT);
  for(int i=0;i<bitLength;i++) {
    digitalWrite(PIN_CLOCK, HIGH);
    delayMicroseconds(TDLY3);
    if(digitalRead(PIN_DATA)==HIGH) {
      data|=(1<<i);
    }
    digitalWrite(PIN_CLOCK, LOW);
    delayMicroseconds(TDLY1);
  }
  pinMode(PIN_DATA, OUTPUT);
  digitalWrite(PIN_DATA, LOW);
  interrupts();
  return data;
}
